/**
 * @license
 * @version 0.4.3
 * The MIT License (MIT)
 * 
 * Copyright (c) 2015 Thomas Roch
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
define("router5",[],function(){var t=function(){function t(t,e){for(var n=0;n<e.length;n++){var r=e[n];r.enumerable=r.enumerable||false;r.configurable=true;if("value"in r)r.writable=true;Object.defineProperty(t,r.key,r)}}return function(e,n,r){if(n)t(e.prototype,n);if(r)t(e,r);return e}}();function e(t,e){if(!(t instanceof e)){throw new TypeError("Cannot call a class as a function")}}var n=function n(t){return"("+(t?t.replace(/(^<|>$)/g,""):"[a-zA-Z0-9-_.~]+")+")"};var r=[{name:"url-parameter",pattern:/^:([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})(<(.+?)>)?/,regex:function a(t){return new RegExp(n(t[2]))}},{name:"url-parameter-splat",pattern:/^\*([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/,regex:/([^\?]*)/},{name:"url-parameter-matrix",pattern:/^\;([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})(<(.+?)>)?/,regex:function a(t){return new RegExp(";"+t[1]+"="+n(t[2]))}},{name:"query-parameter",pattern:/^(?:\?|&)(?:\:)?([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/},{name:"delimiter",pattern:/^(\/|\?)/,regex:function a(t){return new RegExp(t[0])}},{name:"sub-delimiter",pattern:/^(\!|\&|\-|_|\.|;)/,regex:function a(t){return new RegExp(t[0])}},{name:"fragment",pattern:/^([0-9a-zA-Z]+?)/,regex:function a(t){return new RegExp(t[0])}}];var i=function i(t){var e=arguments.length<=1||arguments[1]===undefined?[]:arguments[1];var n=r.some(function(n){var r=t.match(n.pattern);if(!r)return false;e.push({type:n.name,match:r[0],val:r.slice(1,2),otherVal:r.slice(2),regex:n.regex instanceof Function?n.regex(r):n.regex});if(r[0].length<t.length)e=i(t.substr(r[0].length),e);return true});if(!n){throw new Error("Could not parse path.")}return e};var u=function(){function r(t){e(this,r);if(!t)throw new Error("Please supply a path");this.path=t;this.tokens=i(t);this.hasUrlParams=this.tokens.filter(function(t){return/^url-parameter/.test(t.type)}).length>0;this.hasSpatParam=this.tokens.filter(function(t){return/splat$/.test(t.type)}).length>0;this.hasMatrixParams=this.tokens.filter(function(t){return/matrix$/.test(t.type)}).length>0;this.hasQueryParams=this.tokens.filter(function(t){return t.type==="query-parameter"}).length>0;this.urlParams=!this.hasUrlParams?[]:this.tokens.filter(function(t){return/^url-parameter/.test(t.type)}).map(function(t){return t.val.slice(0,1)}).reduce(function(t,e){return t.concat(e)});this.queryParams=!this.hasQueryParams?[]:this.tokens.filter(function(t){return t.type==="query-parameter"}).map(function(t){return t.val}).reduce(function(t,e){return t.concat(e)});this.params=this.urlParams.concat(this.queryParams);this.source=this.tokens.filter(function(t){return t.regex!==undefined}).map(function(t){return t.regex.source}).join("")}t(r,[{key:"_urlMatch",value:function a(t,e){var n=this;var r=t.match(e);if(!r)return null;else if(!this.urlParams.length)return{};return r.slice(1,this.urlParams.length+1).reduce(function(t,e,r){t[n.urlParams[r]]=e;return t},{})}},{key:"match",value:function u(t){var e=this;var n=this._urlMatch(t,new RegExp("^"+this.source+(this.hasQueryParams?"?.*$":"$")));if(!n||!this.hasQueryParams)return n;var r=t.split("?")[1].split("&").map(function(t){return t.split("=")}).reduce(function(t,e){t[e[0]]=e[1];return t},{});if(Object.keys(r).every(function(t){return Object.keys(e.queryParams).indexOf(t)!==1})&&Object.keys(r).length===this.queryParams.length){Object.keys(r).forEach(function(t){return n[t]=r[t]});return n}return null}},{key:"partialMatch",value:function s(t){return this._urlMatch(t,new RegExp("^"+this.source))}},{key:"build",value:function o(){var t=arguments.length<=0||arguments[0]===undefined?{}:arguments[0];var e=arguments.length<=1||arguments[1]===undefined?false:arguments[1];if(!this.params.every(function(e){return t[e]!==undefined}))throw new Error("Missing parameters");if(!e){var r=this.tokens.filter(function(t){return/^url-parameter/.test(t.type)&&!/-splat$/.test(t.type)}).every(function(e){return new RegExp("^"+n(e.otherVal[0])+"$").test(t[e.val])});if(!r)throw new Error("Some parameters are of invalid format")}var a=this.tokens.filter(function(t){return t.type!=="query-parameter"}).map(function(e){if(e.type==="url-parameter-matrix")return";"+e.val[0]+"="+t[e.val[0]];return/^url-parameter/.test(e.type)?t[e.val[0]]:e.match}).join("");var i=this.queryParams.map(function(e){return e+"="+t[e]}).join("&");return a+(i?"?"+i:"")}}]);return r}();var s=function(){function n(){var t=arguments.length<=0||arguments[0]===undefined?"":arguments[0];var r=arguments.length<=1||arguments[1]===undefined?"":arguments[1];var a=arguments.length<=2||arguments[2]===undefined?[]:arguments[2];e(this,n);this.name=t;this.path=r;this.parser=r?new u(r):null;this.children=[];this.add(a);return this}t(n,[{key:"add",value:function r(t){var e=this;if(t instanceof Array){t.forEach(function(t){return e.add(t)});return}if(!(t instanceof n)&&!(t instanceof Object)){throw new Error("Route constructor expects routes to be an Object or an instance of Route.")}if(t instanceof Object){if(!t.name||!t.path){throw new Error("Route constructor expects routes to have an name and a path defined.")}t=new n(t.name,t.path,t.children)}if(this.children.map(function(t){return t.name}).indexOf(t.name)!==-1){throw new Error('Alias "'+t.name+'" is already defined in route node')}if(this.children.map(function(t){return t.path}).indexOf(t.path)!==-1){throw new Error('Path "'+t.path+'" is already defined in route node')}var r=t.name.split(".");if(r.length===1){this.children.push(t);this.children.sort(function(t,e){if(t.path==="/")return 1;if(e.path==="/")return-1;var n=t.parser.hasUrlParams||t.parser.hasSpatParam;var r=e.parser.hasUrlParams||e.parser.hasSpatParam;if(!n&&!r){return t.path&&e.path?t.path.length<e.path.length?1:-1:0}if(n&&!r)return 1;if(!n&&r)return-1;if(!t.parser.hasSpatParam&&e.parser.hasSpatParam)return-1;if(!e.parser.hasSpatParam&&t.parser.hasSpatParam)return 1;var a=(t.path.match(/\//g)||[]).length;var i=(e.path.match(/\//g)||[]).length;if(a<i)return 1;return 0})}else{var a=this.getSegmentsByName(r.slice(0,-1).join("."));if(a){a[a.length-1].add(new n(r[r.length-1],t.path,t.children))}else{throw new Error("Could not add route named '"+t.name+"', parent is missing.")}}return this}},{key:"addNode",value:function a(t,e){this.add(new n(t,e));return this}},{key:"getSegmentsByName",value:function i(t){var e=function e(t,e){var n=e.filter(function(e){return e.name===t});return n.length?n[0]:undefined};var n=[];var r=t.split(".");var a=this.children;var i=r.every(function(t){var r=e(t,a);if(r){a=r.children;n.push(r);return true}return false});return i?n:null}},{key:"getSegmentsMatchingPath",value:function s(t){var e=function e(t,n,r){var a=function(a){var i=t[a];var u=i.parser.partialMatch(n);if(u){r.push(i);Object.keys(u).forEach(function(t){return r.params[t]=u[t]});var s=n.replace(i.parser.build(u),"");if(!s.length){return{v:r}}if(!i.children.length){return{v:null}}return{v:e(i.children,s,r)}}};for(var i in t){var u=a(i);if(typeof u==="object")return u.v}return null};var n=this.parser?[this]:this.children;var r=[];r.params={};return e(n,t,r)}},{key:"getPathFromSegments",value:function o(t){return t?t.map(function(t){return t.path}).join(""):null}},{key:"getPath",value:function l(t){return this.getPathFromSegments(this.getSegmentsByName(t))}},{key:"buildPathFromSegments",value:function f(t){var e=arguments.length<=1||arguments[1]===undefined?{}:arguments[1];return t?t.map(function(t){return t.parser.build(e)}).join(""):null}},{key:"buildPath",value:function h(t){var e=arguments.length<=1||arguments[1]===undefined?{}:arguments[1];return this.buildPathFromSegments(this.getSegmentsByName(t),e)}},{key:"getMatchPathFromSegments",value:function c(t){if(!t)return null;var e=t.map(function(t){return t.name}).join(".");var n=t.params;return{name:e,params:n}}},{key:"matchPath",value:function v(t){return this.getMatchPathFromSegments(this.getSegmentsMatchingPath(t))}}]);return n}();var o={ROUTER_NOT_STARTED:"NOT_STARTED",ROUTER_ALREADY_STARTED:"ALREADY_STARTED",SAME_STATES:"SAME_STATES",CANNOT_DEACTIVATE:"CANNOT_DEACTIVATE",CANNOT_ACTIVATE:"CANNOT_ACTIVATE",TRANSITION_ERR:"TRANSITION_ERR",NODE_LISTENER_ERR:"NODE_ERR",TRANSITION_CANCELLED:"CANCELLED"};function l(){var t=arguments;return function(){return t[0]}}var f=function f(){};var h=typeof window!=="undefined";var c=function c(){return window.location.pathname.replace(/\/$/,"")};var v=function v(t,e,n){return window.history.pushState(t,e,n)};var m=function m(t,e,n){return window.history.replaceState(t,e,n)};var p=function p(t){return window.addEventListener("popstate",t)};var d=function d(t){return window.removeEventListener("popstate",t)};var g=function g(t){var e=t.useHash?window.location.hash.replace(new RegExp("^#"+t.hashPrefix),""):window.location.pathname.replace(new RegExp("^"+t.base),"");return e+window.location.search};var y={};if(h){y={getBase:c,pushState:v,replaceState:m,addPopstateListener:p,removePopstateListener:d,getLocation:g}}else{y={getBase:l(""),pushState:f,replaceState:f,addPopstateListener:f,removePopstateListener:f,getLocation:l("")}}function S(t,e,n,r,a){var i=arguments.length<=5||arguments[5]===undefined?false:arguments[5];t=t||function(){return false};var u=e||[];var s=function s(t){if(!u.length)return true;var e=u[0].length;var a=u[0](n,r,t);if(typeof a==="boolean")t(a?null:true);else if(a&&typeof a.then==="function"){a.then(function(){return t(null)},function(){return t(true)})}else if(e<3&&i)t(null);return false};var o=function o(t){if(t)a(t);else{u=u.slice(1);l()}};var l=function l(){if(t()){a(null)}else{var e=s(o);if(e)a(null)}};l()}function _(t,e){var n=function n(t){return t.split(".").reduce(function(t,e){return t.concat(t.length?t[t.length-1]+"."+e:e)},[])};var r=undefined;var a=e?n(e.name):[];var i=n(t.name);var u=Math.min(a.length,i.length);for(r=0;r<u;r+=1){if(a[r]!==i[r])break}var s=a.slice(r).reverse();var o=i.slice(r);var l=e&&r>0?a[r-1]:"";return{intersection:l,toDeactivate:s,toActivate:o}}function E(t,e,n,r){var a=false;var i=function i(){return a};var u=function u(){return a=true};var s=function s(t){return r(a?o.TRANSITION_CANCELLED:t)};var l=_(e,n);var f=l.intersection;var h=l.toDeactivate;var c=l.toActivate;var v=function v(e,n,r){var a=h.map(function(e){return t._cmps[e]}).filter(function(t){return t&&t.canDeactivate}).map(function(t){return t.canDeactivate});S(i,a,e,n,function(t){return r(t?o.CANNOT_DEACTIVATE:null)})};var m=function m(e,n,r){var a=c.map(function(e){return t._canAct[e]}).filter(function(t){return t});S(i,a,e,n,function(t){return r(t?o.CANNOT_ACTIVATE:null)})};var p=t._onTr;var d=function d(t,e,n){var r=[p];S(i,r,t,e,function(t){return n(t?o.TRANSITION_ERR:null)})};var g=t._cbs["^"+f];var y=function y(t,e,n){var r=g;S(i,r,t,e,function(t){return n(t?o.NODE_LISTENER_ERR:null)},true)};var E=(n?[v]:[]).concat(m).concat(p?d:[]).concat(g&&g.length?y:[]);S(i,E,e,n,s);return u}var k=Array.prototype.slice;var t=function(){function t(t,e){for(var n=0;n<e.length;n++){var r=e[n];r.enumerable=r.enumerable||false;r.configurable=true;if("value"in r)r.writable=true;Object.defineProperty(t,r.key,r)}}return function(e,n,r){if(n)t(e.prototype,n);if(r)t(e,r);return e}}();function e(t,e){if(!(t instanceof e)){throw new TypeError("Cannot call a class as a function")}}var w=function w(t,e,n){return{name:t,params:e,path:n}};var A=function(){t(n,null,[{key:"ERR",value:o,enumerable:true},{key:"transitionPath",value:_,enumerable:true}]);function n(t){var r=this;var a=arguments.length<=1||arguments[1]===undefined?{}:arguments[1];e(this,n);this.started=false;this._onTr=null;this._cbs={};this._cmps={};this._canAct={};this.lastStateAttempt=null;this.lastKnownState=null;this.rootNode=t instanceof s?t:new s("","",t);this.options={useHash:false,hashPrefix:"",base:y.getBase()};Object.keys(a).forEach(function(t){return r.options[t]=a[t]});this.boundOnPopState=this.onPopState.bind(this)}t(n,[{key:"setOption",value:function r(t,e){this.options[t]=e;return this}},{key:"add",value:function a(t){this.rootNode.add(t);return this}},{key:"addNode",value:function i(t,e,n){this.rootNode.addNode(t,e);if(n)this._canAct[t]=n;return this}},{key:"onPopState",value:function u(t){var e=this;var n=t.state||this.matchPath(this.getLocation());if(!n)return;if(this.lastKnownState&&this.areStatesEqual(n,this.lastKnownState))return;this._transition(n,this.lastKnownState,function(t){if(t){var n=e.buildUrl(e.lastKnownState.name,e.lastKnownState.params);y.pushState(e.lastKnownState,"",n)}})}},{key:"onTransition",value:function l(t){this._onTr=t;return this}},{key:"start",value:function f(){var t=this;var e=[].concat(k.call(arguments));var n=e.slice(-1)[0];var r=n instanceof Function?n:null;var a=undefined,i=undefined;if(this.started){if(r)r(o.ROUTER_ALREADY_STARTED);return this}if(e.length>0){if(typeof e[0]==="string")a=e[0];if(typeof e[0]==="object")i=e[0]}this.started=true;var u=this.options;var s=function s(e,n){y.addPopstateListener(t.boundOnPopState);if(r)r(e,n)};if(!a&&!i)a=this.getLocation();if(!i){(function(){i=t.matchPath(a);var e=function e(){return t.navigate(u.defaultRoute,u.defaultParams,{replace:true},s)};if(i){t.lastStateAttempt=i;t._transition(t.lastStateAttempt,t.lastKnownState,function(n,r){if(!n){y.replaceState(t.lastKnownState,"",t.buildUrl(i.name,i.params));s(null,r)}else if(u.defaultRoute)e();else s(n)})}else if(u.defaultRoute){e()}else{s(null)}})()}else{this.lastKnownState=i;y.replaceState(this.lastKnownState,"",this.buildUrl(i.name,i.params));s(null,i)}return this}},{key:"stop",value:function h(){if(!this.started)return this;this.lastKnownState=null;this.lastStateAttempt=null;this.started=false;y.removePopstateListener(this.boundOnPopState);return this}},{key:"getState",value:function c(){return this.lastKnownState}},{key:"isActive",value:function v(t){var e=arguments.length<=1||arguments[1]===undefined?{}:arguments[1];var n=arguments.length<=2||arguments[2]===undefined?false:arguments[2];var r=this.getState();if(!r)return false;if(n||r.name===t){return this.areStatesEqual(w(t,e),r)}return this.areStatesDescendants(w(t,e),r)}},{key:"areStatesEqual",value:function m(t,e){return t.name===e.name&&Object.keys(t.params).length===Object.keys(e.params).length&&Object.keys(t.params).every(function(n){return t.params[n]===e.params[n]})}},{key:"areStatesDescendants",value:function p(t,e){var n=new RegExp("^"+t.name+"\\.(.*)$");if(!n.test(e.name))return false;return Object.keys(t.params).every(function(n){return t.params[n]===e.params[n]})}},{key:"_invokeListeners",value:function d(t){for(var e=arguments.length,n=Array(e>1?e-1:0),r=1;r<e;r++){n[r-1]=arguments[r]}(this._cbs[t]||[]).forEach(function(t){return t.apply(undefined,n)})}},{key:"_addListener",value:function g(t,e,n){var r=t.replace(/^(\*|\^|=)/,"");if(r&&!/^\$/.test(t)){var a=this.rootNode.getSegmentsByName(r);if(!a)console.warn("No route found for "+r+", listener might never be called!")}if(!this._cbs[t])this._cbs[t]=[];this._cbs[t]=(n?[]:this._cbs[t]).concat(e);return this}},{key:"_removeListener",value:function S(t,e){if(this._cbs[t])this._cbs[t]=this._cbs[t].filter(function(t){return t!==e});return this}},{key:"addListener",value:function A(t){return this._addListener("*",t)}},{key:"removeListener",value:function T(t){return this._removeListener("*",t)}},{key:"addNodeListener",value:function b(t,e){return this._addListener("^"+t,e,true)}},{key:"removeNodeListener",value:function P(t,e){this._cbs["^"+t]=[];return this}},{key:"addRouteListener",value:function R(t,e){return this._addListener("="+t,e)}},{key:"removeRouteListener",value:function N(t,e){return this._removeListener("="+t,e)}},{key:"onTransitionStart",value:function L(t){return this._addListener("$start",t)}},{key:"offTransitionStart",value:function O(t){return this._removeListener("$start",t)}},{key:"onTransitionCancel",value:function x(t){return this._addListener("$cancel",t)}},{key:"offTransitionCancel",value:function C(t){return this._removeListener("$cancel",t)}},{key:"onTransitionError",value:function D(t){return this._addListener("$error",t)}},{key:"offTransitionError",value:function j(t){return this._removeListener("$error",t)}},{key:"registerComponent",value:function I(t,e){if(this._cmps[t])console.warn("A component was alread registered for route node "+t+".");this._cmps[t]=e;return this}},{key:"deregisterComponent",value:function $(t){delete this._cmps[t]}},{key:"canActivate",value:function K(t,e){this._canAct[t]=e;return this}},{key:"getLocation",value:function M(){return y.getLocation(this.options)}},{key:"buildUrl",value:function q(t,e){return this.options.base+(this.options.useHash?"#"+this.options.hashPrefix:"")+this.rootNode.buildPath(t,e)}},{key:"buildPath",value:function U(t,e){return this.rootNode.buildPath(t,e)}},{key:"matchPath",value:function z(t){var e=this.rootNode.matchPath(t);return e?w(e.name,e.params,t):null}},{key:"_transition",value:function Z(t,e,n){var r=this;if(this._tr)this._tr();this._invokeListeners("$start",t,e);var a=E(this,t,e,function(a){r._tr=null;if(a){if(a===o.TRANSITION_CANCELLED)r._invokeListeners("$cancel",t,e);else r._invokeListeners("$error",t,e,a);if(n)n(a);return}r.lastKnownState=t;r._invokeListeners("="+t.name,t,e);r._invokeListeners("*",t,e);if(n)n(null,t)});this._tr=a;return function(){return!a||a()}}},{key:"navigate",value:function B(t,e,n,r){if(e===undefined)e={};var a=this;if(n===undefined)n={};if(!this.started){r(o.ROUTER_NOT_STARTED);return}var i=this.buildPath(t,e);var u=this.buildUrl(t,e);if(!i)throw new Error('Could not find route "'+t+'"');var s=w(t,e,i);this.lastStateAttempt=s;var l=this.lastKnownState?this.areStatesEqual(this.lastKnownState,this.lastStateAttempt):false;if(l&&!n.reload){if(r)r(o.SAME_STATES);return}return this._transition(s,this.lastKnownState,function(t,e){if(t){if(r)r(t);return}y[n.replace?"replaceState":"pushState"](a.lastStateAttempt,"",u);if(r)r(null,e)})}}]);return n}();return{RouteNode:s,Router5:A}});